/* Copyright (C) 2024 FIAS Frankfurt Institute for Advanced Studies, Frankfurt / Main
   SPDX-License-Identifier: GPL-3.0-only
   Authors: Felix Weiglhofer [committer], Dominik Smith */

#pragma once

#include "CommonUnpacker.h"
#include "ReadoutConfigLegacy.h"
#include "UnpackMS.h"

namespace cbm::algo::sts
{

  namespace detail
  {
    using UnpackBase = CommonUnpacker<CbmStsDigi, UnpackMS, UnpackMonitorData>;
  }

  class Unpack : public detail::UnpackBase {

   public:
    using Result_t = detail::UnpackBase::Result_t;

    Unpack(const ReadoutConfigLegacy& readout);

    Result_t operator()(const fles::Timeslice&) const;

   private:
    ReadoutConfigLegacy fReadout;
  };

}  // namespace cbm::algo::sts
