/* Copyright (C) 2023 FIAS Frankfurt Institute for Advanced Studies, Frankfurt / Main
   SPDX-License-Identifier: GPL-3.0-only
   Authors: Felix Weiglhofer [committer] */
#include "UnpackChain.h"

#include "config/Yaml.h"

using namespace cbm::algo;
using fles::Subsystem;

void UnpackChain::Init()
{
  if (Opts().Has(Subsystem::TRD)) {
    auto yaml          = YAML::LoadFile((Opts().ParamsDir() / "TrdReadoutSetup.yaml").string());
    fUnpack.fTrdConfig = config::Read<trd::ReadoutConfig>(yaml);
  }
  if (Opts().Has(Subsystem::TRD2D)) {
    auto yaml            = YAML::LoadFile((Opts().ParamsDir() / "Trd2dReadoutSetup.yaml").string());
    fUnpack.fTrd2dConfig = config::Read<trd2d::ReadoutConfig>(yaml);
  }
  fUnpack.Init(Opts().Detectors());
}

Unpack::resultType UnpackChain::Run(const fles::Timeslice& timeslice)
{
  auto result = fUnpack(&timeslice);

  return result;
}
